//
// PropertyRooms.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct PropertyRooms: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var listingKeyNumeric: Double?
    public var roomArea: Double?
    public var roomKeyNumeric: Double?
    public var roomLength: Double?
    public var roomWidth: Double?
    public var listingId: String?
    public var listingKey: String?
    public var roomDescription: String?
    public var roomDimensions: String?
    public var roomKey: String?
    public var roomFeatures: [String]?
    public var roomAreaSource: String?
    public var roomAreaUnits: String?
    public var roomLengthWidthUnits: String?
    public var roomType: String?
    public var modificationTimestamp: Date?
    public var property: Property?

    public init(id: Int? = nil, listingKeyNumeric: Double? = nil, roomArea: Double? = nil, roomKeyNumeric: Double? = nil, roomLength: Double? = nil, roomWidth: Double? = nil, listingId: String? = nil, listingKey: String? = nil, roomDescription: String? = nil, roomDimensions: String? = nil, roomKey: String? = nil, roomFeatures: [String]? = nil, roomAreaSource: String? = nil, roomAreaUnits: String? = nil, roomLengthWidthUnits: String? = nil, roomType: String? = nil, modificationTimestamp: Date? = nil, property: Property? = nil) {
        self.id = id
        self.listingKeyNumeric = listingKeyNumeric
        self.roomArea = roomArea
        self.roomKeyNumeric = roomKeyNumeric
        self.roomLength = roomLength
        self.roomWidth = roomWidth
        self.listingId = listingId
        self.listingKey = listingKey
        self.roomDescription = roomDescription
        self.roomDimensions = roomDimensions
        self.roomKey = roomKey
        self.roomFeatures = roomFeatures
        self.roomAreaSource = roomAreaSource
        self.roomAreaUnits = roomAreaUnits
        self.roomLengthWidthUnits = roomLengthWidthUnits
        self.roomType = roomType
        self.modificationTimestamp = modificationTimestamp
        self.property = property
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case listingKeyNumeric = "ListingKeyNumeric"
        case roomArea = "RoomArea"
        case roomKeyNumeric = "RoomKeyNumeric"
        case roomLength = "RoomLength"
        case roomWidth = "RoomWidth"
        case listingId = "ListingId"
        case listingKey = "ListingKey"
        case roomDescription = "RoomDescription"
        case roomDimensions = "RoomDimensions"
        case roomKey = "RoomKey"
        case roomFeatures = "RoomFeatures"
        case roomAreaSource = "RoomAreaSource"
        case roomAreaUnits = "RoomAreaUnits"
        case roomLengthWidthUnits = "RoomLengthWidthUnits"
        case roomType = "RoomType"
        case modificationTimestamp = "ModificationTimestamp"
        case property = "Property"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(listingKeyNumeric, forKey: .listingKeyNumeric)
        try container.encodeIfPresent(roomArea, forKey: .roomArea)
        try container.encodeIfPresent(roomKeyNumeric, forKey: .roomKeyNumeric)
        try container.encodeIfPresent(roomLength, forKey: .roomLength)
        try container.encodeIfPresent(roomWidth, forKey: .roomWidth)
        try container.encodeIfPresent(listingId, forKey: .listingId)
        try container.encodeIfPresent(listingKey, forKey: .listingKey)
        try container.encodeIfPresent(roomDescription, forKey: .roomDescription)
        try container.encodeIfPresent(roomDimensions, forKey: .roomDimensions)
        try container.encodeIfPresent(roomKey, forKey: .roomKey)
        try container.encodeIfPresent(roomFeatures, forKey: .roomFeatures)
        try container.encodeIfPresent(roomAreaSource, forKey: .roomAreaSource)
        try container.encodeIfPresent(roomAreaUnits, forKey: .roomAreaUnits)
        try container.encodeIfPresent(roomLengthWidthUnits, forKey: .roomLengthWidthUnits)
        try container.encodeIfPresent(roomType, forKey: .roomType)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(property, forKey: .property)
    }
}

